Index: code/trunk/src/libraries/core/Core.cc
===================================================================
--- code/trunk/src/libraries/core/Core.cc	(revision 7380)
+++ code/trunk/src/libraries/core/Core.cc	(revision 7401)
@@ -37,4 +37,5 @@
 
 #include <cassert>
+#include <fstream>
 #include <vector>
 
@@ -171,4 +172,19 @@
         // Create singletons that always exist (in other libraries)
         this->rootScope_.reset(new Scope<ScopeID::Root>());
+
+        // Generate documentation instead of normal run?
+        std::string docFilename;
+        CommandLineParser::getValue("generateDoc", &docFilename);
+        if (!docFilename.empty())
+        {
+            std::ofstream docFile(docFilename.c_str());
+            if (docFile.is_open())
+            {
+                CommandLineParser::generateDoc(docFile);
+                docFile.close();
+            }
+            else
+                COUT(0) << "Error: Could not open file for documentation writing" << endl;
+        }
     }
 
Index: code/trunk/src/libraries/core/Core.h
===================================================================
--- code/trunk/src/libraries/core/Core.h	(revision 7380)
+++ code/trunk/src/libraries/core/Core.h	(revision 7401)
@@ -28,4 +28,15 @@
  */
 
+/**
+    @defgroup CoreGame Core and Game
+    @ingroup Management
+*/
+
+/**
+    @file
+    @ingroup Management CoreGame
+    @brief Declaration of the Core singleton which is used to configure the program basics.
+*/
+
 #ifndef _Core_H__
 #define _Core_H__
@@ -33,5 +44,4 @@
 #include "CorePrereqs.h"
 
-#include <cassert>
 #include <string>
 #include <boost/scoped_ptr.hpp>
Index: code/trunk/src/libraries/core/CoreIncludes.h
===================================================================
--- code/trunk/src/libraries/core/CoreIncludes.h	(revision 7380)
+++ code/trunk/src/libraries/core/CoreIncludes.h	(revision 7401)
@@ -28,12 +28,47 @@
 
 /**
+    @defgroup Factory RegisterObject() and CreateFactory()
+    @ingroup Object
+*/
+
+/**
     @file
-    @brief Definition of macros for Identifiers
+    @ingroup Object Factory
+    @brief Defines several very important macros used to register objects, create factories, and to work with identifiers.
 
-    Every class needs the RegisterObject(class) macro in its constructor. If the class is an interface
-    or the BaseObject itself, it needs the macro RegisterRootObject(class) instead.
+    Every class needs the @c RegisterObject(class) macro in its constructor. If the class is an interface
+    or the @c BaseObject itself, it needs the macro @c RegisterRootObject(class) instead.
 
-    To allow the object being created through the factory, use the CreateFactory(class) macro outside
-    the of the class implementation, so it gets executed before main().
+    To allow the object being created through the factory, use the @c CreateFactory(class) macro outside
+    of the class implementation, so it gets executed statically before @c main(). This will at the same time
+    register @a class in the class-hierarchy. If you don't want @a class to be loadable, but still
+    register it, call @c CreateUnloadableFactory(class).
+
+    Example:
+    @code
+    // Create the factory for MyClass
+    CreateFactory(MyClass);
+
+    // Constructor:
+    MyClass::MyClass()
+    {
+        // Register the object in the Identifier of MyClass
+        RegisterObject(MyClass);
+    }
+    @endcode
+
+    This file also defines a number of other useful macros, like, for example, @c Class(class) which
+    returns the @ref orxonox::Identifier "Identifier" of @a class, or @c ClassByString("class") which
+    returns the Identifier of a class with name @a "class".
+
+    Example:
+    @code
+    // Assigns the Identifier of MyClass
+    Identifier* identifier = Class(MyClass);
+    @endcode
+    @code
+    // Assigns the Identifier of a class named "MyClass"
+    Identifier* identifier = ClassByString("MyClass");
+    @endcode
 */
 
@@ -51,7 +86,7 @@
 
 /**
-    @brief Intern macro, containing the common parts of RegisterObject and RegisterRootObject.
+    @brief Intern macro, containing the common parts of @c RegisterObject and @c RegisterRootObject.
     @param ClassName The name of the class
-    @param bRootClass True if the class is directly derived from OrxonoxClass
+    @param bRootClass True if the class is directly derived from orxonox::OrxonoxClass
 */
 #define InternRegisterObject(ClassName, bRootClass) \
@@ -62,5 +97,5 @@
 
 /**
-    @brief RegisterObject - with and without debug output.
+    @brief Registers a newly created object in the core. Has to be called at the beginning of the constructor of @a ClassName.
     @param ClassName The name of the class
 */
@@ -69,6 +104,9 @@
 
 /**
-    @brief RegisterRootObject - with and without debug output.
+    @brief Registers a newly created object in the core. Has to be called at the beginning of the constructor of @a ClassName.
     @param ClassName The name of the class
+
+    In contrast to RegisterObject, this is used for classes that inherit directly from
+    orxonox::OrxonoxClass, namely all interfaces and orxonox::BaseObject.
 */
 #define RegisterRootObject(ClassName) \
@@ -101,5 +139,5 @@
     /**
         @brief Returns the Identifier with a given name.
-        @param String The name of the class
+        @param name The name of the class
     */
     inline Identifier* ClassByString(const std::string& name)
@@ -110,5 +148,5 @@
     /**
         @brief Returns the Identifier with a given lowercase name.
-        @param String The lowercase name of the class
+        @param name The lowercase name of the class
     */
     inline Identifier* ClassByLowercaseString(const std::string& name)
@@ -119,5 +157,5 @@
     /**
         @brief Returns the Identifier with a given network ID.
-        @param networkID The network ID of the class
+        @param id The network ID of the class
     */
     inline Identifier* ClassByID(uint32_t id)
@@ -130,5 +168,5 @@
         @note This of course only works with OrxonoxClasses.
               The only use is in conjunction with macros that don't know the class type.
-        @param Pointer to an OrxonoxClass
+        @param object Pointer to an OrxonoxClass
     */
     template <class T>
Index: code/trunk/src/libraries/core/DynLib.h
===================================================================
--- code/trunk/src/libraries/core/DynLib.h	(revision 7380)
+++ code/trunk/src/libraries/core/DynLib.h	(revision 7401)
@@ -29,4 +29,10 @@
 
 // 08/11/2009: Small adjustments for Orxonox by Fabian 'x3n' Landau
+
+/**
+    @file
+    @ingroup Management CoreGame
+    @brief Declaration of DynLib which represents a dynamically loaded module.
+*/
 
 #ifndef _Core_DynLib_H__
@@ -61,5 +67,5 @@
 namespace orxonox
 {
-    /** Resource holding data about a dynamic library.
+    /** %Resource holding data about a dynamic library.
         @remarks
             This class holds the data required to get symbols from
@@ -69,6 +75,4 @@
         @since
             27 January 2002
-        @see
-            Resource
     */
     class _CoreExport DynLib
Index: code/trunk/src/libraries/core/DynLibManager.h
===================================================================
--- code/trunk/src/libraries/core/DynLibManager.h	(revision 7380)
+++ code/trunk/src/libraries/core/DynLibManager.h	(revision 7401)
@@ -30,4 +30,10 @@
 // 08/11/2009: Small adjustments for Orxonox by Fabian 'x3n' Landau
 
+/**
+    @file
+    @ingroup Management CoreGame
+    @brief Declaration of DynLibManager, used to load modules at runtime.
+*/
+
 #ifndef _Core_DynLibManager_H__
 #define _Core_DynLibManager_H__
@@ -56,28 +62,36 @@
 
         public:
-            /** Default constructor.
-                @note
-                    <br>Should never be called as the singleton is automatically
-                    created during the creation of the Root object.
-                @see
-                    Root::Root
+            /**
+            @brief
+                Default constructor.
+            @note
+                Should never be called as the singleton is automatically
+                created during the creation of the Root object.
+            @see
+                Root::Root
             */
             DynLibManager();
 
-            /** Default destructor.
-                @see
-                    Root::~Root
+            /**
+            @brief
+                Default destructor.
+            @see
+                Root::~Root
             */
             virtual ~DynLibManager();
 
-            /** Loads the passed library.
-                @param
-                    filename The name of the library. The extension can be omitted
+            /**
+            @brief
+                Loads the passed library.
+            @param filename
+                The name of the library. The extension can be omitted
             */
             DynLib* load(const std::string& filename);
 
-            /** Unloads the passed library.
-            @param
-            filename The name of the library. The extension can be omitted
+            /**
+            @brief
+                Unloads the passed library.
+            @param lib
+                A pointer to the library object
             */
             void unload(DynLib* lib);
Index: code/trunk/src/libraries/core/Event.cc
===================================================================
--- code/trunk/src/libraries/core/Event.cc	(revision 7380)
+++ code/trunk/src/libraries/core/Event.cc	(revision 7401)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @brief Implementation of the classes Event and EventState.
+*/
 
 #include "Event.h"
Index: code/trunk/src/libraries/core/Event.h
===================================================================
--- code/trunk/src/libraries/core/Event.h	(revision 7380)
+++ code/trunk/src/libraries/core/Event.h	(revision 7401)
@@ -27,4 +27,15 @@
  */
 
+/**
+    @defgroup Event Events
+    @ingroup Core
+*/
+
+/**
+    @file
+    @ingroup Event
+    @brief Declaration of the classes Event and EventState.
+*/
+
 #ifndef _Event_H__
 #define _Event_H__
@@ -54,10 +65,10 @@
         An event state is a state of an object, which can be changed by events.
         Event states are changed through functions. Possible functions headers for set event states are:
-         - memoryless state: function()
-         - boolean state:    function(bool state)
-         - individual state: function(bool state, SomeClass originator)
+         - memoryless state: <tt>function()</tt>
+         - boolean state:    <tt>function(bool state)</tt>
+         - individual state: <tt>function(bool state, SomeClass originator)</tt>
 
         Note that SomeClass may be any class deriving from BaseObject. You will not receive events from originators of other classes.
-        The actual class for SomeClass must be specified as the second argument of the XMLPortEventState macro.
+        The actual class for SomeClass must be specified as the second argument of the XMLPortEventState() macro.
 
         The this pointer of the affected object is hidden in the functors, because the events are processed in the BaseObject, but some
Index: code/trunk/src/libraries/core/EventIncludes.h
===================================================================
--- code/trunk/src/libraries/core/EventIncludes.h	(revision 7380)
+++ code/trunk/src/libraries/core/EventIncludes.h	(revision 7401)
@@ -26,4 +26,10 @@
  *
  */
+
+/**
+    @file
+    @ingroup Event
+    @brief Definition of the XMLPortEventState() macro, as well as some more useful macros.
+*/
 
 #ifndef _EventIncludes_H__
Index: code/trunk/src/libraries/core/GUIManager.cc
===================================================================
--- code/trunk/src/libraries/core/GUIManager.cc	(revision 7380)
+++ code/trunk/src/libraries/core/GUIManager.cc	(revision 7401)
@@ -110,6 +110,4 @@
         After Lua setup tolua++-elements are linked to Lua-state to give Lua access to C++-code.
         Finally initial Lua code is executed (maybe we can do this with the CEGUI startup script automatically).
-    @param renderWindow
-        Ogre's render window. Without this, the GUI cannot be displayed.
     @return true if success, otherwise false
     */
@@ -237,4 +235,6 @@
     @param name
         The name of the GUI
+    @param bHidePrevious
+        If true all displayed GUIs on the stack, that are below this GUI are hidden.
 
         The function executes the Lua function with the same name in case the GUIManager is ready.
Index: code/trunk/src/libraries/core/GUIManager.h
===================================================================
--- code/trunk/src/libraries/core/GUIManager.h	(revision 7380)
+++ code/trunk/src/libraries/core/GUIManager.h	(revision 7401)
@@ -27,4 +27,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup Graphics
+*/
 
 #ifndef _GUIManager_H__
Index: code/trunk/src/libraries/core/Game.h
===================================================================
--- code/trunk/src/libraries/core/Game.h	(revision 7380)
+++ code/trunk/src/libraries/core/Game.h	(revision 7401)
@@ -29,6 +29,7 @@
 /**
 @file
+@ingroup Management CoreGame
 @brief
-    Declaration of Game Singleton.
+    Declaration of Game Singleton which is responsible for running the game.
  */
 
@@ -53,5 +54,5 @@
 
 /**
-@def
+@brief
     Adds a new GameState to the Game. The second parameter is the name as string
     and every following paramter is a constructor argument (which is usually non existent)
Index: code/trunk/src/libraries/core/GameMode.cc
===================================================================
--- code/trunk/src/libraries/core/GameMode.cc	(revision 7380)
+++ code/trunk/src/libraries/core/GameMode.cc	(revision 7401)
@@ -33,5 +33,5 @@
     bool GameMode::bShowsGraphics_s = false;
     bool GameMode::bPlaysSound_s    = false;
-    bool GameMode::bHasServer_s     = false;
+    bool GameMode::bIsServer_s      = false;
     bool GameMode::bIsClient_s      = false;
     bool GameMode::bIsStandalone_s  = false;
Index: code/trunk/src/libraries/core/GameMode.h
===================================================================
--- code/trunk/src/libraries/core/GameMode.h	(revision 7380)
+++ code/trunk/src/libraries/core/GameMode.h	(revision 7401)
@@ -29,5 +29,6 @@
 /**
     @file
-    @brief Declaration of the GameMode class.
+    @ingroup Management CoreGame
+    @brief Declaration of the GameMode class which stores and returns the current mode of the game.
 */
 
@@ -40,4 +41,5 @@
 namespace orxonox
 {
+    /// Helper class, stores and returns the current mode of the game.
     class _CoreExport GameMode
     {
@@ -47,16 +49,16 @@
         public:
 // tolua_begin
-            static bool showsGraphics() { return bShowsGraphics_s; }
-            static bool playsSound()    { return bPlaysSound_s; }
-            static bool hasServer()     { return bHasServer_s; }
-            static bool isClient()      { return bIsClient_s; }
-            static bool isStandalone()  { return bIsStandalone_s; }
-            static bool isMaster()      { return bIsMaster_s; }
+            static bool showsGraphics() { return bShowsGraphics_s; }    ///< Returns true if the game shows graphics, false if it is in text-console mode
+            static bool playsSound()    { return bPlaysSound_s; }       ///< Returns true if the game is able to play sounds
+            static bool isServer()      { return bIsServer_s; }         ///< Returns true if we're currently a server (online)
+            static bool isClient()      { return bIsClient_s; }         ///< Returns true if we're currently a client (online)
+            static bool isStandalone()  { return bIsStandalone_s; }     ///< Returns true if we're in standalone mode (offline)
+            static bool isMaster()      { return bIsMaster_s; }         ///< Returns true if we're in control of the game (either standalone or server)
 // tolua_end
 
-            static void setPlaysSound   (bool val) { bPlaysSound_s    = val; }
-            static void setHasServer    (bool val) { bHasServer_s     = val; updateIsMaster(); }
-            static void setIsClient     (bool val) { bIsClient_s      = val; updateIsMaster(); }
-            static void setIsStandalone (bool val) { bIsStandalone_s  = val; updateIsMaster(); }
+            static void setPlaysSound   (bool val) { bPlaysSound_s    = val; }                      ///< Defines if the game can play sounds
+            static void setIsServer     (bool val) { bIsServer_s      = val; updateIsMaster(); }    ///< Defines if the program is in server mode (online)
+            static void setIsClient     (bool val) { bIsClient_s      = val; updateIsMaster(); }    ///< Defines if the program is in client mode (online)
+            static void setIsStandalone (bool val) { bIsStandalone_s  = val; updateIsMaster(); }    ///< Defines if the program is in standalone mode (offline)
 
         private:
@@ -65,15 +67,16 @@
             ~GameMode();
 
+            /// Checks if we're in control of the game (either standalone or server).
             static void updateIsMaster()
             {
-                bIsMaster_s = (bHasServer_s || bIsStandalone_s);
+                bIsMaster_s = (bIsServer_s || bIsStandalone_s);
             }
 
             static bool bShowsGraphics_s;                   //!< global variable that tells whether to show graphics
             static bool bPlaysSound_s;                      //!< global variable that tells whether to sound works
-            static bool bHasServer_s;                       //!< global variable that tells whether this is a server
-            static bool bIsClient_s;
-            static bool bIsStandalone_s;
-            static bool bIsMaster_s;
+            static bool bIsServer_s;                        //!< global variable that tells whether this is a server (online)
+            static bool bIsClient_s;                        //!< global variable that tells whether this is a client (online)
+            static bool bIsStandalone_s;                    //!< global variable that tells whether the game is running in standalone mode (offline)
+            static bool bIsMaster_s;                        //!< global variable that tells whether we're in control of the game (standalone or server)
     }; // tolua_export
 } // tolua_export
Index: code/trunk/src/libraries/core/GameState.h
===================================================================
--- code/trunk/src/libraries/core/GameState.h	(revision 7380)
+++ code/trunk/src/libraries/core/GameState.h	(revision 7401)
@@ -29,4 +29,5 @@
 /**
 @file
+@ingroup Management CoreGame
 @brief
     Definition of GameState class.
Index: code/trunk/src/libraries/core/GraphicsManager.h
===================================================================
--- code/trunk/src/libraries/core/GraphicsManager.h	(revision 7380)
+++ code/trunk/src/libraries/core/GraphicsManager.h	(revision 7401)
@@ -29,5 +29,11 @@
 
 /**
+    @defgroup Graphics Graphics and GUI
+    @ingroup Core
+*/
+
+/**
 @file
+@ingroup Graphics
 @brief
     Declaration of GraphicsManager Singleton.
Index: code/trunk/src/libraries/core/Identifier.cc
===================================================================
--- code/trunk/src/libraries/core/Identifier.cc	(revision 7380)
+++ code/trunk/src/libraries/core/Identifier.cc	(revision 7401)
@@ -217,5 +217,4 @@
     /**
         @brief Sets the name of the class.
-        @param name The name
     */
     void Identifier::setName(const std::string& name)
@@ -253,5 +252,4 @@
     /**
         @brief Sets the network ID to a new value and changes the entry in the ID-Identifier-map.
-        @param id The new network ID
     */
     void Identifier::setNetworkID(uint32_t id)
